#include "emmix.h"
void F77_SUB(intsum)(double *pux, double *pdist, double *pdof, 
double *ret, int *pp, int *pL)
{
int p=*pp, L=*pL,ltail=1,logp=0;
double ux = *pux, dist=*pdist,dof=*pdof;
double tmp1,tmp2;
double one=1.0, two=2.0, dp=(double)p;
double s0,y;
y=one/(one+ux*ux/(dof+dp));
tmp1=fnn(y,dof,dp,L);
if(ux>0) {
s0=fnn(one,dof,dp,L);
tmp1=two*s0-tmp1;
}
tmp2=gammafn((dof+dp+one)/two)/gammafn((dof+dp)/two)/two/M_SQRT_PI;
tmp1=tmp1*tmp2;
tmp2=pt( (ux*sqrt(one+two/(dof+dp))),dof+dp+two,ltail,logp);
tmp2 +=tmp1;
s0=(digamma((dof+dp+one)/two)-digamma((dof+dp)/two)+one);
tmp1=ux*(one/(dof+p)-one/(dof+dist))*dt(ux,dof+dp,logp);
ret[0]=s0+(tmp1-tmp2)/pt(ux,dof+dp,ltail,logp);
}
double fnn(double y,double dof, double dp, int k)
{
double sum=0.0,two=2.0,half=0.5;
int ltail=1,logp=0,i;
for(i=1;i<=k;i++)
sum +=beta((dof+dp)/two,half+(double)i)*pbeta(y,(dof+dp)/two,
	half+(double)i,ltail,logp)/(double)i;
return(sum);
}
